proc InitGIDProject { dir } { 
    CodeBright::ChangeMenu
}

namespace eval CodeBright {
}

proc CodeBright::ConditionsSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Conditions"] -command [list GidUtils::OpenWindow CONDITION]
    $w add separator
    $w add command -label [_ "Tables"] -command [list DWProblemDataWindow Boundary_Condition_Flux]
    $w add command -label [_ "Import Conditions"] -command [list CodeBright::ImportBondaryConditionsFlux]    
    $w configure -postcommand ""
}

proc CodeBright::ChangeMenu { } {        
    GiDMenu::InsertOption Calculate [list [= "Calculate from the beginning (save files will be erased!)"]] 2 PRE CodeBright::ReCalculate "" "" insert =

    
    GidChangeDataLabel "Conditions" ""
    GidAddUserDataOptionsMenu [= "Conditions"] "CodeBright::ConditionsSubmenu %W" 2
    
    # GiDMenu::InsertOption Calculate [list [= "Time-dependent flux boundary condition"]] 2 PRE CodeBright::ImportBondaryConditionsFlux "" "" insert =
    
    # GiDMenu::InsertOption "Data" [list "My Help"] 0 PRE "" "" "" insert _
    # GiDMenu::InsertOption "Data" [list "My Help" "Import from meteocat"] 0 PRE CodeBright::ImportBondaryConditionsFlux "" "" replace _
    # GiDMenu::InsertOption "Data" [list "My Help" "Tables"] 1 PRE CodeBright::ImportBondaryConditionsFlux "" "" replace _


    GiDMenu::UpdateMenus
}

proc CodeBright::ReCalculate { } {
    set model_name [GiD_Info project ModelName]
    set file_tail [file tail $model_name]
    set filename [file join ${model_name}.gid ${file_tail}_save.dat]
    if { [file exists $filename] } {
	file delete $filename
    }
    if { [file exists $filename] } {
	    WarnWinText [= "Error, restart file '$filename' already exists"]
    } else {
        GiD_Process Mescape Utilities Calculate
    }
}

proc GiD_Event_BeforeRunCalculation { batfilename basename dir problemtypedir gidexe args } {
#CodeBright::WriteBondaryConditionsFlux

    set num_var [GiD_AccessValue get gendata Number_of_variables_to_define]
    if {$num_var>0} {
        array set var {}
        for {set idx 1} {$idx<=$num_var} {incr idx} {
            set var($idx) [GiD_AccessValue get gendata Variable_$idx]
        }
        set extension "_bcf.dat"
        set filename [file join $dir $basename$extension]
        
        #TOASK Que hacer cuando las variables tiene longitud diferente
        #TOASK veo que algunas lineas acaban en 0, no entiendo el criterio
        #TOASK veo que tanto el numero de horas como los indices, se les añade ".0" es necesario?
        set horas [expr [lindex [set var(1)] 1] / 2 ]
        
        set data "$horas\t\t\t\t\t\n"
        append data "-3\t1\t2\t3\t\t\n"
        for {set id_h 1} {$id_h<=$horas} {incr id_h} {
            for {set idx 1} {$idx<=$num_var} {incr idx} {
                #W "lrange la_lista [expr $id_h*2] [expr $id_h*2 +1]"
                #W "ES: [lrange [set var($idx)] [expr $id_h*2] [expr $id_h*2 +1]]"
                append data [format {%s %s } {*}[lrange [set var($idx)] [expr $id_h*2] [expr $id_h*2 +1]]]
            }
            append data "\n"
        }
        GidUtils::WriteFile $filename $data
        # file.write(str(horas) + "\t\t\t\t\t\n")
        # file.write("-3\t1\t2\t3\t\t\n")
        # idx = 0
        # for index, row in df_horas.iterrows():
        #     i = str(idx)
        #     idx = idx + 1
        #     v = str(row["valor_lectura"]/factor)
        #     t = "\t"
        #     if v=="0.0":
        #         x = succion
        #         y = "100"
        #     else:
        #         x = "0"
        #         y = "-100"            
        #     file.write(i + t + v + t + i + t + x + t + i + t + y + "\n")
    }
}

proc CodeBright::ImportBondaryConditionsFlux { } {
    if { [GidUtils::AreWindowsDisabled] } {
	return
    }  
    set w .gid.win_example
    InitWindow $w [= "Time-dependent flux boundary condition"] CodeBrightImportBondaryConditions "" "" 1
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    ttk::frame $w.top
    ttk::label $w.top.title_text -text [= "Bondary Conditions are going to be download from \nanalisi.transparenciacatalunya.cat/resource/nzvn-apee"]
   
    ttk::frame $w.information -relief ridge

    package require widget::dateentry

    
    set ::END_DATE [clock format [expr {[clock seconds] - 60*60*24}] -format "%d/%m/%Y"]
    set num_days 1
    set ::START_DATE [clock format [expr {[clock scan $::END_DATE -format "%d/%m/%Y" ] - 60*60*24*$num_days}] -format "%d/%m/%Y"]

    ttk::label $w.information.label_start -text [= "From"]
    set start [widget::dateentry $w.information.start_date -textvariable ::START_DATE -dateformat "%d/%m/%Y" -firstday monday]
    ttk::label $w.information.label_end -text [= "To"]
    set end [widget::dateentry $w.information.end_date -textvariable ::END_DATE -dateformat "%d/%m/%Y" -firstday monday]

    ttk::label $w.information.label_station -text [= "Station Code"]
    set ::CodeBright::station_code "X4"
    ttk::entry $w.information.station_code -textvariable ::CodeBright::station_code

    ttk::label $w.information.label_variable -text [= "Variable Code"]
    set ::CodeBright::variable_code "35"
    ttk::entry $w.information.variable_code -textvariable ::CodeBright::variable_code

    ttk::label $w.information.label_factor -text [= "Apply Factor"]
    set ::CodeBright::factor "10"
    ttk::entry $w.information.factor -textvariable ::CodeBright::factor

    ttk::label $w.information.label_suction -text [= "Suction"]
    set ::CodeBright::suction "-10"
    ttk::entry $w.information.suction -textvariable ::CodeBright::suction

    ttk::label $w.information.label_gama_liquid -text [= "Gama for liquid"]
    set ::CodeBright::gama_liquid "100"
    ttk::entry $w.information.gama_liquid -textvariable ::CodeBright::gama_liquid

    ttk::label $w.information.label_initial_time -text [= "Initial time"]
    set ::CodeBright::initial_time "0"
    ttk::entry $w.information.initial_time -textvariable ::CodeBright::initial_time

    ttk::label $w.information.label_frequency -text [= "Frequency(h)"]
    set ::CodeBright::frequency "1"
    ttk::entry $w.information.frequency -textvariable ::CodeBright::frequency


    ttk::frame $w.bottom
    ttk::button $w.bottom.start -text [= "Cancel"] -command "destroy $w"
    ttk::button $w.bottom.random -text [= "Import"] -command "CodeBright::DoImport $w \[$start get\] \[$end get\] \$::CodeBright::station_code \$::CodeBright::variable_code \$::CodeBright::factor \$::CodeBright::suction \$::CodeBright::gama_liquid \$::CodeBright::initial_time \$::CodeBright::frequency"

    grid $w.top.title_text -sticky ew -padx 6 -pady 6
    grid $w.top -sticky new
    grid $w.information.label_start $w.information.start_date -sticky ew -padx 6 -pady 6   
    grid $w.information.label_end $w.information.end_date -sticky ew -padx 6 -pady 2   
    grid $w.information.label_station $w.information.station_code -sticky ew -padx 6 -pady 2
    grid $w.information.label_variable $w.information.variable_code -sticky ew -padx 6 -pady 2
    grid $w.information.label_factor $w.information.factor -sticky ew -padx 6 -pady 2
    grid $w.information.label_suction $w.information.suction -sticky ew -padx 6 -pady 2
    grid $w.information.label_gama_liquid $w.information.gama_liquid -sticky ew -padx 6 -pady 2
    grid $w.information.label_initial_time $w.information.initial_time -sticky ew -padx 6 -pady 2
    grid $w.information.label_frequency $w.information.frequency -sticky ew -padx 6 -pady 2
    grid $w.information -sticky nsew
    
    grid $w.bottom.start $w.bottom.random -padx 6
    grid $w.bottom -sticky sew -padx 6 -pady 6
    if { $::tcl_version >= 8.5 } { grid anchor $w.bottom center }
    grid rowconfigure $w 1 -weight 1
    grid columnconfigure $w 0 -weight 1    
}
proc CodeBright::DoImport {w start_date end_date station_code variable_code factor suction gama_liquid initial_time frequency} {
    #set start_date [$start get]
    #set end_date [$end get]
    # set station_code [set $station_code_varname]
    # set variable_code [set $variable_code_varname]
    # set factor [set $factor_varname]
    # set suction [set $suction_varname]
    # set gama_liquid [set $gama_liquid_varname]
    #W "CodeBright::DoImport $w $start_date $end_date $station_code $variable_code $factor $suction $gama_liquid $initial_time $frequency"

    if {$frequency != 1} {
        W "Not implemented yet, only available frequency (1 hour)"
    }

    set desde [clock format [clock scan $start_date -format "%d/%m/%Y" ] -format "%Y-%m-%d"]
    set hasta [clock format [clock scan $end_date -format "%d/%m/%Y" ] -format "%Y-%m-%d"]
    set num_dias [expr { int(( [clock scan $end_date -format "%d/%m/%Y" ] - [clock scan $start_date -format "%d/%m/%Y" ] ) / (60*60*24)) }]


    global ::CodeBright::DoingImport
    set ::CodeBright::DoingImport 0
    ::GidUtils::CreateAdvanceBar [= "Importing data"] [= "Percentage"] ::CodeBright::DoingImport [expr $num_dias * 3 ]  [list WarnWin [= "User stop"]]

    


    package require http
    package require tls    
    ::http::register https 443 [list ::tls::socket -autoservername 1]
    set url "https://analisi.transparenciacatalunya.cat/resource/nzvn-apee.json"

    
    set query [http::formatQuery \
      {$select} data_lectura,valor_lectura \
      codi_estacio $station_code \
      codi_variable $variable_code \
      {$where} "data_lectura>='$desde' AND data_lectura<'$hasta'" \
      {$order} id \
      {$limit} [expr {48 * $num_dias}] \
    ]

#->-np- source {F:\Compack\codebright.gid\CODE_BRIGHT_2024_03.gid\CODE_BRIGHT_2024_03.tcl}
#W $url?$query

    set headers ""
    set _timeout 90000 

    set token [http::geturl $url?$query -headers $headers -timeout $_timeout]

    if {[http::status $token] eq "ok"} {
        set ::CodeBright::DoingImport $num_dias

        package require gid_json    
        set ::data_json [::gid_json::json2dict [http::data $token]]

        # W [llength [lindex $::data_json 0]]
        # W [dict keys [lindex [lindex $::data_json 0] 0]]

        set data_per_hour [dict create]

        set time 0
        foreach lectura [lindex $::data_json 0] {
            if {[expr $time%24]==0} {
                incr ::CodeBright::DoingImport
            }
            set day_hour [clock format [clock scan [dict get $lectura data_lectura] -format %Y-%m-%dT%H:%M:%S.000] -format "%Y-%m-%dT%H"]
            #CAUTION, format must be sort-able 
            if {[dict exists $data_per_hour $day_hour]} {
                dict set data_per_hour $day_hour [expr {[dict get $data_per_hour $day_hour]+[dict get $lectura valor_lectura]}]
            } else {
                dict set data_per_hour $day_hour [dict get $lectura valor_lectura]
            } 
            incr time          
        }
        
        # W [llength [dict keys $data_per_hour]]
        # W [lsort [dict keys $data_per_hour]]

        set num_hour [llength [dict keys $data_per_hour]]

        set first_column [list #N#]
        lappend first_column [expr 2*$num_hour]

        set second_column [list #N#]
        lappend second_column [expr 2*$num_hour]

        set third_column [list #N#]
        lappend third_column [expr 2*$num_hour]
     
        set time 0
        foreach index [lsort [dict keys $data_per_hour]] {
            if {[expr $time%24]==0} {
                incr ::CodeBright::DoingImport
            }
            set value [dict get $data_per_hour $index]
            lappend first_column [expr $time+$initial_time] [format "%.3f" $value]
            # if {$value >= $factor} {} 
            if {$value > 0.0} {
                lappend second_column [expr $time+$initial_time] $suction
                lappend third_column [expr $time+$initial_time] $gama_liquid
            } else {
                lappend second_column [expr $time+$initial_time] "0"
                lappend third_column [expr $time+$initial_time] [expr -1.0*$gama_liquid]
            }
            incr time
        }

        GiD_AccessValue set gendata Number_of_variables_to_define 3
        GiD_AccessValue set gendata Variable_1 $first_column
        GiD_AccessValue set gendata Variable_2 $second_column
        GiD_AccessValue set gendata Variable_3 $third_column

        GidUtils::CloseWindow PROBLEMDATA
        # W "Everything correct"
        set ::CodeBright::DoingImport [expr $num_dias * 3 ]

        #W [info class data_json]
        #W [::gid_json::json2string $data_json]
        # foreach line [split $data_json \n] {
        #     array set g [split $line =]
        # }
        # foreach index [array names g] {
        #     W "g($index): $g($index) \n"
        # }

        # set data [http::data $token]
        # package require gid_json
        # set data_json [::gid_json::json2dict $data]
       
    } else {
        set err [http::error $token]
        W $err
    }
    
    http::cleanup $token 

    # dict for {key value} $data_json {
    #     W "Key:$key value:$value \n"
    # }
    
    

    # destroy $w
}